package ogss;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Container;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.util.ArrayList;
import java.util.Calendar;

import java.io.FileInputStream;
import java.io.InputStreamReader;

import javax.swing.BoxLayout;
import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;
import javax.swing.JTextArea;

import java.util.regex.Pattern;
import java.util.regex.Matcher;

/* GUI̍쐬 */

public class AppFrame extends JFrame {

	   private static final long serialVersionUID = 1L;
	   private JButton juliusButton;
	   private JButton cancelButton;
	   private JButton changeButton;
	   private JButton allClearButton;
	   private JButton clearButton;
	   private JButton saveButton;
	   private JButton nextFile;
	   private JLabel inputLabel,anaphoraLabel,midLabel,detailLabel;//,talkLabel,vocaLabel,detailLabel;
	   private static JLabel runLabel;

	   static JTextArea textarea1, textarea2, textarea3, textarea4;
	   private JScrollPane scrollPane1, scrollPane2, scrollPane3, scrollPane4;
	   private JPanel panel1,panel2,panel3,panel_input;

	   private static JRadioButton radio1, radio2, radio3;			//͕@
	   private static JRadioButton radio_sk1, radio_sk2;			//Ɖ͂ȂƂ
	   private static JRadioButton radio_SR1, radio_SR2, radio_SR3;	//bȂƂ
	   private static JRadioButton radio_n, radio_t, radio_tb;		//ΘbȂƂ(̌nIm/̌nI+̒m)
	   private static JRadioButton radio_out1, radio_out2;        //ڍ׏o͂ȂƂ

	   private ButtonGroup group;

	   private static JTabbedPane tabPane;

	   static int flg[]={0,0,0,0};
	   static String in = "";

	   private static ArrayList<String> Recognizer_marker;

//////////////////////////////////////////////////////
//////////////////////////////////////////////////////

	   public AppFrame() {
		   Recognizer_marker = new ArrayList<String>();
		   // F̖OƔFʒ񎦂ꏏɕ\邽߂̃}[J[Cconft@CŒ`Ă閼O쐬܂D쐬}[J[̗:[#1 julius]
		    try {
		    	BufferedReader br = new BufferedReader(new InputStreamReader(new FileInputStream(ParseConfig.getRecognizerConfPath())));
		    	String line ="";
    			Pattern pt = Pattern.compile("-SR (.*?) (.+)");
		    	while((line = br.readLine())!= null){
		    		Matcher mt = pt.matcher(line);
		    		if(mt.matches())
		    			Recognizer_marker.add("[#"+(Recognizer_marker.size()+1)+" "+mt.group(1)+"]");
		    	}
		    	br.close();
		    } catch(IOException e) {
		    	e.printStackTrace();
		    }


		  this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

		  this.setSize(810,710);
		  this.setTitle("OGSS Speech Recognizer ver1.0");

		  inputLabel = new JLabel("<html><br><br><font color=#C71585>͕@</font></html>");
		  anaphoraLabel = new JLabel("<html><br><html><font color=#C71585>Ɖ</font></html>");
		  midLabel = new JLabel("<html><br><html><font color=#C71585>F</font></html>");
		  detailLabel = new JLabel("<html><br><html><font color=#C71585>ҏWo</font></html>");//
		  ///////////////////

	      runLabel = new JLabel("       julius stop....");

		  //julius{^
	      juliusButton = new JButton("julius");
	      juliusButton.setSize(200,30);
	      juliusButton.addActionListener(
	    		  new ActionListener(){
	    	            public void actionPerformed(ActionEvent e){
	    	            	//julius̎s
	    	            	if(flg[0]==0){
	    	            			flg[0]++;
	    	            			Thread t = new Thread(new JuliusTask(),"julius");
	    	            			t.start();

	    	            			//t@C͂̏ꍇ
	    	            			if(option()==2){
	    	            				Thread r = new Thread(new SelectTask(),"julius");
	    	            				r.start();

	    	            			}
	    	     		   }
	    	            }
	    	        }
	      );

	      //nextfile{^
	      nextFile = new JButton("nextFile");
	      nextFile.setSize(200,30);
	      nextFile.addActionListener(
	    		  new ActionListener(){
	    	            public void actionPerformed(ActionEvent e){
	    	            	if(JuliusTask.FileNUM<33)
	    	            		JuliusTask.FileNUM++;
	    	            }
	    		  }

	      );

	      //stop{^
	      cancelButton = new JButton("stop");
	      cancelButton.setSize(200,30);
	      cancelButton.addActionListener(
	    		  new ActionListener(){
	    			  public void actionPerformed(ActionEvent e){
	    				  cancel();
	    			  }
	    		  }
	      );

	      //Change{^
	      changeButton = new JButton("Change");
	      changeButton.setSize(200,30);
	      changeButton.addActionListener(
	    		  new ActionListener(){
	    			  public void actionPerformed(ActionEvent e){
	    				  addChangeMark();
	    			  }
	    		  }
	      );

	      //allClear{^
	      allClearButton = new JButton("logClear");
	      allClearButton.setSize(200,30);
	      allClearButton.addActionListener(
	    		  new ActionListener(){
	    			  public void actionPerformed(ActionEvent e){
	    				  logAllClear();
	    			  }
	    		  }
	      );

	      //clear{^
	      clearButton = new JButton("clear");
	      clearButton.setSize(200,30);
	      clearButton.addActionListener(new ActionListener(){
	    	  public void actionPerformed(ActionEvent e) {

	    		  if(tabPane.getSelectedIndex() == 0) textarea1.setText("");
	    		  else if(tabPane.getSelectedIndex() == 1) textarea2.setText("");
	    		  else if(tabPane.getSelectedIndex() == 2) textarea3.setText("");

	    	  }
	    	});

	      //save{^
	      saveButton = new JButton("save");
	      saveButton.addActionListener(new Savefile(this));
	      saveButton.setSize(200,30);

	      //eLXg
	      textarea1 = new JTextArea();
	      textarea1.setWrapStyleWord(true);
	      textarea1.setLineWrap(false);

	      //XN[̖ߍ
	      scrollPane1 = new JScrollPane(textarea1);
	      scrollPane1.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
	      scrollPane1.setPreferredSize(new Dimension(660, 512));

	      //eLXg
	      textarea2 = new JTextArea();
	      textarea2.setWrapStyleWord(true);
	      textarea2.setLineWrap(false);

	      //XN[̖ߍ
	      scrollPane2 = new JScrollPane(textarea2);
	      scrollPane2.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
	      scrollPane2.setPreferredSize(new Dimension(660, 512));

	      //eLXg
	      textarea3 = new JTextArea();
	      textarea3.setWrapStyleWord(true);
	      textarea3.setLineWrap(false);

	      //XN[̖ߍ
	      scrollPane3 = new JScrollPane(textarea3);
	      scrollPane3.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
	      scrollPane3.setPreferredSize(new Dimension(660, 512));

	      //eLXg
	      textarea4 = new JTextArea();
	      textarea4.setWrapStyleWord(true);
	      textarea4.setLineWrap(false);

	      //XN[̖ߍ
	      scrollPane4 = new JScrollPane(textarea4);
	      scrollPane4.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
	      scrollPane4.setPreferredSize(new Dimension(660, 512));

	      //^u
	      tabPane = new JTabbedPane();
	      tabPane.addTab("Output Log",scrollPane1);
	      tabPane.addTab("Recognition Result",scrollPane2);
	      tabPane.addTab("Juli Result",scrollPane3);
	      tabPane.addTab("Extraction / conversion", scrollPane4);


	      //WI{^i}CNEt@Cj

	      radio1 = new JRadioButton("}CN");
	      radio2 = new JRadioButton("Pt@C");
	      radio3 = new JRadioButton("t@C");
	      switch(ParseConfig.getInputType()){
	      	case 1 : radio1 = new JRadioButton("}CN",true);
	      	case 2 : radio2 = new JRadioButton("Pt@C",true);
	      	case 3 : radio3 = new JRadioButton("t@C",true);
	      }
	      //WI{^iƉ́j
	      radio_sk1 = new JRadioButton("Ȃ");
	      radio_sk2 = new JRadioButton("");
	      if(!ParseConfig.getExecAnaphRes())
	    	  radio_sk1 = new JRadioButton("Ȃ",true);
	      else radio_sk2 = new JRadioButton("",true);

	      //WI{^iFj
	      radio_SR1 = new JRadioButton("b̂");
	      radio_SR2 = new JRadioButton("+hC");
	      radio_SR3 = new JRadioButton("++hC");
	      switch(ParseConfig.getRecogType()){
	      	case 1 : radio_SR1 = new JRadioButton("b̂",true);
	      	case 2 : radio_SR2 = new JRadioButton("+hC",true);
	      	case 3 : radio_SR3 = new JRadioButton("++hC",true);
	      }

	      //WI{^iҏWój//
	      radio_out1 = new JRadioButton("Ȃ");
	      radio_out2 = new JRadioButton("",true);

	      ///////////////////////////////////

	      //WI{^̃O[v
	      group = new ButtonGroup();
	      group.add(radio1);
	      group.add(radio2);
	      group.add(radio3);

	      group = new ButtonGroup();
	      group.add(radio_sk1);
	      group.add(radio_sk2);

	      group = new ButtonGroup();
	      group.add(radio_SR1);
	      group.add(radio_SR2);
	      group.add(radio_SR3);

	      group = new ButtonGroup();
	      group.add(radio_n);
	      group.add(radio_t);
	      group.add(radio_tb);

	      group = new ButtonGroup();//
	      group.add(radio_out1);//
	      group.add(radio_out2);//

	      ////////////////////////////////
	      //pl
	      panel_input =new JPanel();
	      panel_input.setLayout(new BoxLayout(panel_input, BoxLayout.Y_AXIS));
	      panel_input.add(inputLabel);
	      panel_input.add(radio1);
	      panel_input.add(radio2);
	      panel_input.add(radio3);

	      panel_input.add(anaphoraLabel);
	      panel_input.add(radio_sk1);
	      panel_input.add(radio_sk2);

	      panel_input.add(midLabel);
	      panel_input.add(radio_SR1);
	      panel_input.add(radio_SR2);
	      panel_input.add(radio_SR3);

	      panel_input.add(detailLabel);//
	      panel_input.add(radio_out1);
	      panel_input.add(radio_out2);


	      panel1 = new JPanel();
	      panel1.setLayout(new FlowLayout());
	      panel1.add(juliusButton);
	      panel1.add(cancelButton);
	      panel1.add(nextFile);
	      panel1.add(changeButton);
	      panel1.add(allClearButton);
	      panel1.add(runLabel);

	      panel2 = new JPanel();
	      panel2.add(tabPane);

	      panel3 = new JPanel();
	      panel3.setLayout(new FlowLayout());
	      panel3.add(clearButton);
	      panel3.add(saveButton);

	      //ReiƖߍ
	      Container c = getContentPane();

	      c.add(panel1,BorderLayout.NORTH);
	      c.add(panel2,BorderLayout.CENTER);
	      c.add(panel3,BorderLayout.SOUTH);
	      c.add(panel_input,BorderLayout.WEST);


////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////

	   }

	   //󋵂̕\
	   public static void run(String str){
		   runLabel.setText(str);
	   }

	   //FʂeeLXg֕\
	   public static void sendtextarea(String str){

		   textarea1.append(str);
		   textarea1.append("\n");

		   Calendar cal1 = Calendar.getInstance();

		    int year = cal1.get(Calendar.YEAR);        //݂̔N擾
		    int month = cal1.get(Calendar.MONTH) + 1;  //݂̌擾
		    int day = cal1.get(Calendar.DATE);         //݂̓擾
		    int hour = cal1.get(Calendar.HOUR_OF_DAY); //݂̎擾
		    int minute = cal1.get(Calendar.MINUTE);    //݂̕擾
		    int second = cal1.get(Calendar.SECOND);    //݂̕b擾

		    String date = "i" + year + "/" + month + "/" + day + " " + hour + ":" + minute + ":" + second + "j";

		    // Fʂƕ\F̖O̐D
		   for(int i=0; i<Recognizer_marker.size();i++){
			   if(str.startsWith(Recognizer_marker.get(i))) in=Recognizer_marker.get(i);
		   }

		   //sentence(o͌)Ŏn܂1\
		   if (str.startsWith("sentence")){
			   if(str.startsWith("sentence1:"))
				   	textarea2.append("\n\nF" + in + date );

			   textarea2.append("\n");
			   textarea2.append(str);
			   textarea2.append("\n");
		   }

		   //phseq(f\L)Ŏn܂1\
		   if (str.startsWith("phseq")){
			   textarea2.append(str);
			   textarea2.append("\n");
		   }

		   //cmscore(Mx)Ŏn܂1\
		   if (str.startsWith("cmscore")){
			   textarea2.append(str);
			   textarea2.append("\n");
		   }
	   }


	   //Fc[̃vZXI
	   public void cancel() {
	      System.out.println("cancel");
		  textarea1.append("I܂\n");

	      if(flg[0]>0){ JuliusTask.stop(); flg[0]=0;}
	      runLabel.setText("       julius stop....");

	      Juli.juli.juli_clear();

	   }

	   public static void addChangeMark(){
		      System.out.println("Change");
			  textarea4.append("`FW{^܂I\n");
		   String line = new String();
			ArrayList<String> In = new ArrayList<String>();

			In.clear();
			//2011/1/12 ̂̃t@ČĂł̂ŏC
			try {
				BufferedReader br = new BufferedReader(new FileReader("DL2.txt"));

				while((line = br.readLine()) != null) {
					In.add(line);
				}
				In.add("/");
				BufferedWriter bw = new BufferedWriter(new OutputStreamWriter(new FileOutputStream("DL2.txt")));

				//Ob̏
				for(int p = 0; p < In.size(); p++) {
					bw.write((String)In.get(p));
					bw.newLine();  //s
				}
				bw.close();

	        } catch(IOException e) {
	        	e.printStackTrace();
	        }

	        In.clear();
			try {
				BufferedReader br = new BufferedReader(new FileReader("DL1.txt"));

				while((line = br.readLine()) != null) {
					In.add(line);
				}
				In.add("/");
				BufferedWriter bw = new BufferedWriter(new OutputStreamWriter(new FileOutputStream("DL1.txt")));

				//Ob̏
				for(int p = 0; p < In.size(); p++) {
					bw.write(In.get(p));
					bw.newLine();  //s
				}

				bw.close();

	        } catch(IOException e) {
	        	e.printStackTrace();
	        }
	        ////////////////////2011/2/15test폜\
	        In.clear();

	        //////////////////////////////

	   }

	   public void logAllClear(){
		      System.out.println("logAllClear");
			  textarea4.append("b폜܂I\n");
			try {
				BufferedWriter bw = new BufferedWriter(new OutputStreamWriter(new FileOutputStream("DL2.txt")));
				bw.close();
				BufferedWriter bw2 = new BufferedWriter(new OutputStreamWriter(new FileOutputStream("DL1.txt")));
				bw2.close();
	        } catch(IOException e) {
	        	e.printStackTrace();
	        }
	   }

	   //WI{^̔
	   public static int option() {//}CNort@Cort@C

			if(radio1.isSelected()==true) return(1);
			else if(radio2.isSelected()==true) return(2);
			else if(radio3.isSelected()==true) return(3);
			return (0);
		}

	   public static int option_anaphora(){//Ɖ͂邩Ȃ
		    if(radio_sk1.isSelected()==true) return(1);
			else if(radio_sk2.isSelected()==true) return(2);
			return (0);
	   }

	   public static int option_recogType(){//1FbFA2F召bA3F咆b
		    if(radio_SR1.isSelected()==true) return(1);
			else if(radio_SR2.isSelected()==true) return(2);
			else if(radio_SR3.isSelected()==true) return(3);
			return (0);
	   }

	   public static int option_detail(){//ҏW̌ʂJuli Resultւ̕\ؑ
		   if(radio_out1.isSelected()==true) return(1);
			else if(radio_out2.isSelected()==true) return(2);
			return (0);
	   }

	   public static int option_tab(){
		   return(tabPane.getSelectedIndex());
	   }
/////////////////////////////////////////////////////////
/////////////////////////////////////////////

	}